﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectMonorail.Drawnings;
public class DrawningLocomotiveCompareByType : IComparer<DrawningLocomotive?>
{
    public int Compare(DrawningLocomotive? x, DrawningLocomotive? y)
    {
        if (x == null || x.EntityLocomotive == null)
        {
            return 1;
        }
        if (y == null || y.EntityLocomotive == null)
        {
            return -1;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return y.GetType().Name.CompareTo(x.GetType().Name);
        }
        var speedCompare = y.EntityLocomotive.Speed.CompareTo(x.EntityLocomotive.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }
        return y.EntityLocomotive.Weight.CompareTo(x.EntityLocomotive.Weight);
    }
}